Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2014059 (CVE-2021-22960) - CVE-2021-22960 llhttp: HTTP Request Smuggling when parsing the body of chunked requests
Summary: CVE-2021-22960 llhttp: HTTP Request Smuggling when parsing the body of chunke...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2021-22960
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 2014066 2014109 2014110 2014111 2014112 2014113 2014114 2014115 2014124 2014125 2014126 2014127 2014128 2014135 2027643 2027645 2027646 2031772 2086786 2086787 2086788 2086789 2087163
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-10-14 11:58 UTC by Cedric Buissart
Modified: 2022-09-13 09:55 UTC (History)
14 users (show)

Fixed In Version: llhttp 6.0.6, llhttp 2.1.4, node 12.22.7, node 14.18.1, node 16.11.1
Doc Type: If docs needed, set a value
Doc Text:
An HTTP Request Smuggling (HRS) vulnerability was found in the llhttp library, used by Node.JS. During the parsing of chunked messages, the chunk size parameter was not validated properly. In situations where HTTP conversations are being proxied (such as proxy, reverse-proxy, load-balancer), an attacker can use this flaw to inject arbitrary messages through the proxy. The highest threat from this vulnerability is to confidentiality and integrity.
Clone Of:
Environment:
Last Closed: 2022-02-01 22:32:51 UTC
Embargoed:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2021:5171 0 None None None 2021-12-15 19:28:08 UTC
Red Hat Product Errata RHSA-2022:0041 0 None None None 2022-01-06 18:40:05 UTC
Red Hat Product Errata RHSA-2022:0246 0 None None None 2022-01-25 09:24:04 UTC
Red Hat Product Errata RHSA-2022:0350 0 None None None 2022-02-01 21:14:52 UTC
Red Hat Product Errata RHSA-2022:4914 0 None None None 2022-06-06 09:26:56 UTC

Description Cedric Buissart 2021-10-14 11:58:21 UTC
The parse ignores chunk extensions when parsing the body of chunked requests. This leads to HTTP Request Smuggling (HRS) under certain conditions.

The fix for this is included in llhttp v2.1.4 and v6.0.6.

Impacts:

    All versions of the 16.x, 14.x, and 12.x releases lines.

Comment 1 Cedric Buissart 2021-10-14 12:11:40 UTC
Created nodejs tracking bugs for this issue:

Affects: fedora-all [bug 2014066]

Comment 2 Cedric Buissart 2021-10-14 13:43:51 UTC
Created nodejs tracking bugs for this issue:

Affects: epel-all [bug 2014109]


Created nodejs:10/nodejs tracking bugs for this issue:

Affects: fedora-all [bug 2014110]


Created nodejs:12/nodejs tracking bugs for this issue:

Affects: fedora-all [bug 2014111]


Created nodejs:13/nodejs tracking bugs for this issue:

Affects: fedora-all [bug 2014112]


Created nodejs:14/nodejs tracking bugs for this issue:

Affects: fedora-all [bug 2014113]


Created nodejs:15/nodejs tracking bugs for this issue:

Affects: fedora-all [bug 2014114]


Created nodejs:16/nodejs tracking bugs for this issue:

Affects: fedora-all [bug 2014115]

Comment 5 Cedric Buissart 2021-10-14 16:53:18 UTC
HackerOne report (currently private) : https://hackerone.com/reports/1238709

Comment 13 errata-xmlrpc 2021-12-15 19:28:06 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2021:5171 https://access.redhat.com/errata/RHSA-2021:5171

Comment 14 errata-xmlrpc 2022-01-06 18:40:03 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 7

Via RHSA-2022:0041 https://access.redhat.com/errata/RHSA-2022:0041

Comment 15 errata-xmlrpc 2022-01-25 09:24:00 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.4 Extended Update Support

Via RHSA-2022:0246 https://access.redhat.com/errata/RHSA-2022:0246

Comment 16 errata-xmlrpc 2022-02-01 21:14:49 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2022:0350 https://access.redhat.com/errata/RHSA-2022:0350

Comment 17 Product Security DevOps Team 2022-02-01 22:32:49 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2021-22960

Comment 18 errata-xmlrpc 2022-06-06 09:26:53 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 7

Via RHSA-2022:4914 https://access.redhat.com/errata/RHSA-2022:4914


Note You need to log in before you can comment on or make changes to this bug.